.\" ************************************************************************
.\"
.\" CSA.mm: decode multipart/form-data variables.
.\" Copyright (C) 2000,2001,2002 Carlo Strozzi <carlos@linux.it>
.\"
.\" This program is free software; you can redistribute it and/or modify
.\" it under the terms of the GNU General Public License as published by
.\" the Free Software Foundation; either version 2 of the License, or
.\" (at your option) any later version.
.\"
.\" This program is distributed in the hope that it will be useful,
.\" but WITHOUT ANY WARRANTY; without even the implied warranty of
.\" MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
.\" GNU General Public License for more details.
.\"
.\" You should have received a copy of the GNU General Public License
.\" along with this program; if not, write to the Free Software
.\" Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.\"
.\" ************************************************************************
.\"
.\" Formatting of a paper with the `mm' troff macro package. The `mm'
.\" package (Memorandum Macros) is the most widely used among the ones
.\" that come with troff (groff), it is well-documented, end it is the
.\" one that I prefer over `me' or `ms', at least for moderately complex
.\" needs.
.\" -------------------------------------------------------------
.\" Troff pre-viewing can be done nicely also on a text terminal, with
.\" the `nroff' command. Note: formatting requires two steps, to resolve
.\" cross-references, and the inclusion of external .eps files requires
.\" optuion '-U'. For example:
.\"
.\" groff -U -mm CSA.mm >/dev/null; groff -U -mm CSA.mm >CSA.ps
.\"
.\" In this case Postscript output is required, as there are pictures
.\" (that are included with the .PSPIC macro). If the optput Postscript
.\" file is then converted to PDF format with ps2pdf(1), pictures will
.\" also convert nicely, with colors and everything :-)
.\"
.\" For ASCII output:
.\"
.\" groff -U -mm -Tlatin9 CSA.mm >/dev/null; groff -U -mm CSA.mm -Tlatin9
.\"
.\" For ASCII output without overstrikes/underlines add the switches
.\" '-P-b' e '-P-u' to groff. Of course pictures will not make it through
.\" to the output ASCII document.
.\"
.\" Hyphenation: check groff(1) output in the various versions, and
.\" insert explicit hyphenation points in the input source text where
.\" appropriate, with the ``\%'' escape sequence.
.\" -------------------------------------------------------------
.\" $Id: CSA.mm,v 1.1.1.1 2003/03/17 11:37:29 carlo Exp $
.\" -------------------------------------------------------------
.\" Sizes in inches for A4 paper, with the relevant mm(7) macro.
.\" See 'info gs' for more.
.\" .PGFORM 6.66i 11.6929i .8i 1
.\"
.\" Override default page header.
.PH "'Command Scripting Architecture - White Paper''Pag. %'"
.\"
.\" Definitions for Italian.
.\" See /usr/share/groff/tmac/tmac.m and groff_mm(7).
.\"
.\" Redefine .LO RN
.\" .ds LetRN "Con riferimento a:
.\"
.\" Redefine .LO SJ
.\" .ds LetSJ OGGETTO:
.\"
.\" Set a custom date format.
.ds localdate "March 17th, 2003 (Draft)
.ND \*[localdate]
.\" 
.\" Heading fonts.
.ds HF B B B B B B B
.\"
.\" Font size.
.ps 12
.\"
.\" Declare reference file. Note: using references requires two
.\" passes trough groff, i.e. it must actually be called twice.
.\" The first pass sets special markers and creates a temporary
.\" referemce file xxx.tmp; the second pass actually resolves all
.\" references and writes the actual reference file xxx.qrf.
.\" The situation is toggled at every new run.
.INITR csaref
.\"
.\" Standard cover-page (currently COVER/COVEND do no longer work. Use MT).
.\" .COVER
.TL
.ce
Command Scripting Architecture
.ce
Technical White Paper
.sp .3i
.AF "TeXne s.r.l.
.AU "Carlo Strozzi
.AT "Systems Engineer
.AU "Phone (+39) 0523 883 732
.AS 0
.in 0
.po 1.25i
This paper describes \fBCSA\fP (Command Scripting Architecture)
and how to design programs based on it. CSA is a simple programming
environment based on the UNIX\*F
.FS
UNIX is a registered trademark of The Open Group
.FE
shell, aimed at the rapid prototyping of Web-based services.
This document is a work in progress, and a lot remains
to be done to make it a real reference manual.
At the moment, the only detailed documentation available
is a few example programs and the extensive comments contained in the
various CSA library source files.

Revision: \*[localdate]

Copyright (C) 2000-2002 by Carlo Strozzi.
.br
This information is free; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This work is distributed in the hope that it will be useful,   
but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this work; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.AE
.\" .COVEND (currently COVER/COVEND do no longer work. Use MT)
.\"
.\" MT diventa superfluo in presenza di COVER/COVEND.
.MT 4
.\"
.\" Two-column mode.
.\" .2C
.\" ---------------------------------------------------------------
.H 1 Introduction
For a thorough understanding of this paper you need to have a good
knowledge of the UNIX/Linux Programming Environment, that is the
\fIshell\fP and the main \fIShell Utilities\fP, like
\fIsed\fP, \fIgrep\fP, \fIfind\fP, etc. A bit of \fIC\fP language
knowledge won't hurt either. The utilities to which I refer in the
rest of this document are the GNU incarnation of such tools. Among
them, the most important to CSA is the AWK programming language, and
in particular Mike Brennan's \fImawk\fP\*F. Wherever I talk about
AWK in the rest of the document I will usually mean \fImawk\fP, unless
stated otherwise.
.FS
\fIftp://ftp.whidbey.net/pub/brennan/\fP
.FE
It is definitely required that the reader has a good knowledge of the
\fIrc\fP\*F shell,
.FS
\fIhttp://www.star.le.ac.uk/~tjg/rc/\fP
.FE
a rather simple scripting language which syntax is
half-way between the C shell and the Bourne shell.
Of course it is necessary to know the technology the World Wide Web
is built on, and in particular the workings of the Common Gateway
Interface\*F, or CGI for short.
.FS
\fIhttp://hoohoo.ncsa.uiuc.edu/cgi/overview.html\fP
.FE
Most important, to really grasp the CSA philosopy
I definitely recommend that you read the resources listed in the
bibliography.
.\" ---------------------------------------------------------------

.H 1 "Why Unix commands, CGI and the Shell ?
This is probably the first question one would ask. The short answer
might be: ``because I like them'' :-)
.br
A lengthier explanation is that I like simple and effective things;
it may sound old-fashioned to talk about CGI and shell scripts in
these days of Java, C# and SOAP, but in spite of all the hype that
has built around those novelties, I have so far yet to see something
that they do, that cannot be done with a simpler, cheaper and more
traditional approach like the classical shell+utilities UNIX cornerstone.
The shell and its countless utilities are very effective, readily available
and well-understood tools, and because of they widspread usage they
are usually more robust and properly debugged than newer environments.
But probably the most important benefit is that you can re-use your
system-administration knowledge to build fairly complex Web applications,
without having to learn ``the new hot programming language of the day''.
After all, this general approach is typical of the UNIX programming
environment, that gets the most from existing components by making them
work together, leveraging on what others have built and thus
maximizing productivity.
Finally, many useful applications either still lack, or will never
provide, the possibility to be accessed over the Web, either through a
human-targeted HTML interface or as an application-oriented Web Service.
With a bit of \fIshell glue\fP, this can be overcome, and a stand-alone
system can thus become part of a larger, web-based distributed
application. It is like providing the original appliance with a
\fIWeb adapter\fP, where others can tap into through the usual and
well-understood CGI Application Programming Interface.

Beside being used as an adapter layer, a CSA system can also be used as
an application system in its own respect, especially if the services
that need to be provided are simple and do not require sophisticated
back-end components or complex database systems.
.\" ---------------------------------------------------------------

.H 1 "The CSA Layout
Building CGI scripts that do simple and self-contained actions may
be easy, and indeed is. Designing more sophisticated Web application
services requires a bit more thinking, and especially an overall system
architecture to refer to. Figure
.GETST csa-fig
, shows the internal structure of a typical CSA system. The picture
must be read from top down and lists the levels, or \fIlayers\fP,
through which a request coming from a client (i.e. often a user's  Web
browser) gets processed to perform a given task.
The working data storage used by the system can reside
either on the local system or (less often) on a remote server. In the latter
case it can be accessed through one of the many standard,
usually IP\*F-based, communication protocols.
.FS
\fIInternet Protocol\fP
.FE
The exchange of information between the blocks takes place along the
boundaries marked by the horizontal lines. Vertical lines are there
only to separate the various areas of the picture, and they have
a merely typographic purpose. For example, the \fICNS\fP block receives
data from the \fICSA\fP layer, and returns formatted replies back to
clients directly through the HTTP server.
.\" One-column mode.
.\" .1C
.DF
.\" .nr Df 5
.FG "CSA Layout" "" "" csa-fig
.PSPIC "CSA.eps"
.DE
.\" Two-column mode.
.\" .2C

An explanation of each block follows, not necessarily in the same top-down
order as in the picture, but in a way that the explanation of each block
will provide the context to understand the subsequent parts.
.\" ---------------------------------------------------------------

.H 2 "HTTP Server
CSA uses the ubiquitous Hyper Text Transport Protocol (HTTP) as its main
communication channel to the outside world. CSA library functions receive
incoming requests through the usual Common Gateway Interface.
Since it is based on HTTP, the interface that CSA exposes to
clients is always \fClient/Server\fP, \fIPoint-to-Point\fP and
\fITransaction-Oriented\fP, i.e. it is the most typical Web API.
The \fIwire format\fP, i.e. the data structures that travel between
a Web client and a CSA application is standard MIME, partly compliant
with an interesting proposed standard called MIME-RPC\*F. Higher
compatibility with that standard is planned with future CSA versions.
.FS
\fIhttp://www.mime-rpc.com\fP
.FE
.\" ---------------------------------------------------------------

.H 2 "CDS - CSA Data Storage
This is where CSA work data live, either (or both) stored on local
storage devices or on remote networked systems, that can be reached
through standard communications protocols, like HTTP, NFS, FTP, LDAP,
ODBC, and the many others.
This layer is shown in the figure on a separate level and not
connected with any other blocks, because it can be used by any of them
to read and store work data when needed.
As a shell-based architecture, CSA interfaces the aforementioned
communication systems by means of specialized shell utilities,
such as \fInetcat\fP, \fIsendmail\fP, and so on. The code needed to make
proficient use of such underlying systems does therefore not need to be
provided by CSA but is readily available from external tools.
Once again, the classical ``UNIX toolkit'' approach favours
the reuse of existing code, and allows us to build a working system
in a fraction of the time that would otherwise be necessary.
.\" ---------------------------------------------------------------

.H 2 "CNS - Custom Name Space
This is the application system proper, and it is completely specific
to the task that needs to be performed. The programming code contained
in this block is application-dependent, and it comprises also all the
\fIbatch\fP procedures, interactive commands and ancillary components
that are specific to a given CSA application.
.\" ---------------------------------------------------------------

.H 2 "CSA - Standard CSA Library
This layer provides CSA common functions, like \fIcsaExit()\fP,
\fIcsaPrintMsg()\fP, \fIcsaLoadLib()\fP, and many others, as well as
several small utility programs. Variables and functions in this block
are stored in a set of common library files, not dependent on the
specific CSA application. Such libraries are loaded automatically at the
beginning of each CSA program run, and exactly what libraries are loaded
depends on the type of program that is being run.
.\" ---------------------------------------------------------------

.H 1 "Programming languages
Of the many shells that are available
I picked \fIrc\fP, originally created for
the Plan 9\*F project and then ported to UNIX by Byron Rakitzis.
.FS
Vedere \fIhttp://www.fywss.com/plan9/\fP
.FE
In my view, this shell offers a clean syntax and a few clever features
that make it better than Bourne derivatives (\fIksh\fP, \fIbash\fP, etc.)
as a Web CGI scripting interpreter.
As a true 4th generation language (4GL), the UNIX shell makes it
possible to tackle complex software projects by focusing on
the overall system, rather than on the implementation details.
Shell scripts rely heavily on external utilities and their
specialized languages, and therefore tend to be smaller, easier to
code and
less prone to bugs than programs written in more traditional
programming languages.

However, no matter how sophisticated a command shell is,
it is always clumsy and awkward at performing fine-grained
manipulations on the data, not even in its most feature-packed
incarnations, like \fIbash\fP or \fIzsh\fP. Trying and do most
of the job without resorting to external programs, if at all
possible, is anyway against the very philosophy of the shell
paradigm, and may even result in slower code. I therefore
prefer to use a bare-bones shell, with no frills but fast
at loading and with
a small memory footprint; \fIrc\fP, with its C-like, clean syntax
and a bunch of minimal but rather clever features, fits the job
perfectly. Since it never does implicit automatic re-parsing
of variables, it is also much more secure than Bourne workalikes
when it comes to handling untrustable user input, a very common
situation on the Web.

While many high-level tasks can be coded with the shell, things
change when we get to lower-level components that require sophistication
or efficiency. Unless an external
UNIX utility is already available for the desired task, we will have
to code the relevant component ourself, resorting to a classical 3GL
language, like \fIC\fP or, less drastically, \fIAWK\fP.
Regarding \fImawk(1)\fP, its execution speed is so high that it
can sometimes be faster than an equivalent, possibly not very optimized,
C program, as shown in the following example\*F:
.FS
The \fIseq(1)\fP utility may not be available on non-Linux systems.
.FE

.ft CW
.nf
$ time seq 500 >/dev/null

real    0m0.039s
user    0m0.040s
sys     0m0.000s

$ time mawk 'BEGIN {while(++i <= 500) print i}' >/dev/null

real    0m0.010s
user    0m0.010s
sys     0m0.000s
.ft P
.fi

As you can see, in this case the AWK program is much faster than \fIseq\fP!
Whatever the
language of choice, however, it must have a small memory footprint
and must be fast at loading and executing; unfortunately, many mainstream
and indeed powerful interpreters, such as \fIPerl\fP o \fITcl\fP, do
not fit this bill awfully well.

The main drawback of the shell+utilities approach is that the number
of system processes needed to perform a given task may sometimes be
rather high. \fIrc\fP, in particular, has very few built-in
features, as its name (\fIrun-command\fP) implies.
This can be mitigated
by coding external programs in lightweight programming languages, so
that processes load fast and do not stay around in memory for too long.

The number of processes should be kept at a minimum also through a
careful program design. For instance, suppose that we need to check
that two files cointain two lines each. A newbe \fIrc\fP programmer may be
tempted to do it in the following 3GL-like fashion:

.ft CW
.nf
if (test `{wc -l < file1} -eq 2 && test `{wc -l < file2} -eq 2) {
   echo file1 and file2 contain two lines each
}
.ft P
.fi

Now, if we consider than both \fItest(1)\fP and \fIwc(1)\fP are external
utilities, and that the backtick \f(CW`{}\fP and redirection ``\f(CW<\fP''
operators spawn one subshell each, we end up with eight system processes
in one single line of shell code! That could indeed be a problem on
a loaded Web server. A more experienced \fIrc\fP programmer could
observe how the wc(1) command behaves when multiple files are specified
on its command-line:

.ft CW
.nf
$ wc -l file1 file2
     2 file1
     2 file2
     4 total
.ft P
.fi

and optimize the above code in a number of ways, for instance:

.ft CW
.nf
* = `{wc -l file1 file2}
if (~ $1 2 && ~ $3 2) {
   echo file1 and file2 contain two lines each
}
.ft P
.fi

This has reduced the number of processes to only two! Of course this was
a trivial case, but it gives you an idea of the approach. See section
``\fBTips and tricks\fP'' for other hints to efficient shell coding.

No matter how carefully you design your code, shell-based
programming will anyway require more system processes than a
classical self-contained approach.
For good performance
you should therefore make sure that the operating system
hosting your application can run an adequately high number
of simultaneous tasks\*F.
.FS
See \fILinux Journal\fP issue 71, page 42.
.FE

.H 1 "The CSA name space
The \fIrc\fP shell, on which CSA is based, exports all variables
to the program environment, making them global to large portions
of code.
Because of this, we have the need to establish a precise naming
convention for variable names, also
to make the latter as self-documenting
as possible. Being the shell a typeless environment
with a continuous dynamic re-casing between types, using
a naming scheme that contentrates on data types (like Hungarian
Notation) would make no sense. I therefore decided to apply a convention
based on the variable \fIscope\fP, that is on its purpose.
.\" ---------------------------------------------------------------

.H 2 "Variables and functions
First of all, we need a way to distinguish between the CSA internal functions
and the application-defined ones. Secondly, it is often
necessary to collectively ``label'' particular sets of variables, like
those that come from a Web \fIform\fP or from a CDS table query. The
labelling process is done by prefixing the desired names with a
common prefix of one or more letters; this is
what I call \fIname-bundling\fP.

Among the many prefixes that can be used for bundling, a few of them
are reserved to CSA or are used internally by the \fIrc\fP shell or
by other underlying utility programs.
The reserved prefixes are:
.BVL .2i
.LI \f(CWv[n]\fP
Internal CSA variables have names that begin with the letter ``v'',
followed by an integer. Such names should be left alone and never
used by application programs. For example, ``\f(CWv1\fP'', ``\f(CWa3\fP''
and so on are reserved CSA variable names.
.LI \f(CWcsa\fP
CSA common library functions
.LI \f(CWCSA_\fP
CSA global variables.
.LI \f(CWfn_\fP
\fIrc\fP function definitions
.LE

In addition to reserved prefixes there are others that, although not
strictly reserved, are simply typical, or \fIconventional\fP, and
they are:
.BVL .2i
.LI \f(CWWWW_\fP
Decoded HTML form variables.
.LI \f(CWISO_\fP
Variables that are to be inserted in HTML response pages and forms.
Such variables are derived from their unencoded versions by replacing
special characters with their ISO representations (i.e. the \fInewline\fP
becomes &#10;, and so on). CGI response variables should always be
encoded like this, also to prevent the so
called \fIcross-site scripting\fP\*F vulnerabilities.
.FS
\fIhttp://www.cert.org/tech_tips/malicious_code_mitigation.html\fP
.FE
.LI \f(CWURI_\fP
These are similar to \f(CWISO_\fP variables, but the escaping of
special characters is
done according to RFC 1378 and the resulting values are meant to
be inserted in \fIUniform Resource Indicator\fP (URI) strings
(i.e. the \fInewline\fP becomes %0A, and so on).
.LI \f(CWIN_\fP
Variables that are meant to be inserted in HTML response pages
in the form of \fIcomplex entry fields\fP, such as \f(CW<select>\fP and
\f(CW<radio>\fP elements.
.LI \f(CWOUT_\fP
Variables to be inserted in HTML response pages, in which the formatting
is done according to some program-specific criteria. This happens when
the relation between the variable content and the output value isn't
functional but tabular, like a \f(CW<select>\fP field value and the
associated descriptive label.
.LI \f(CWCNS_VARNAME\fP
CNS-layer global IPC variables.
.LE

From the name-space point of view, a program, its input
forms and its response pages can be seen as a single entity.
It does therefore make sense that they all share the full program
variable \fInamespace\fP, through replaceable tags that have the same names
as the variables themselves. For example, an output page template
may contain the following tags:

.nf
.ft CW
$[name1]
$[ISO_name1]
$[URI_name1]

\[char46]..
.ft P
.fi

If the output page of one CGI program is in turn the input form of another
(or the same) program, those names that make up form entry-fields will be
returned to the target program prefixed by \f(CWWWW_\fP, to keep them
from clashing with other program variables (which would be very poor
security).

Since with rc(1) everything is global and loaded in the program
environment, \fBnever\fP trust a locally defined variable without
first setting it to null, or initializing it to a known value.
All the initialization should be done at the beginning of the
application program. For clarity, general variables should be set either
to null \fB()\fP or to a known value, while variables that will
be used by the program to contain file names should be initialized
to the \f(CW/dev/null\fP literal string.
\fIInter-Program Communication\fP (IPC) information will normally
be used without initialization. They are passed from a parent
process to its children through the environment, and can be passed
back from a child to a parent with the \fIcsaSource()\fP CSA library
function.

Variables in the \fIrc\fP shell are actually \fIlists\fP of elements,
separated by the octal character \e001.
If they have to be passed to programs written in other programming
languages they must be properly re-formatted. If necessary, they can be
turned into ordinary scalar values with the \fIrc\fP operator ``\fI$^\fP''.
For instance, we can define a \fIlinearized\fP value of the variable
and store it into a name that is the one of the original variable, suffixed
by an underscore ``_'':

.ft CW
.nf
.ce
VARNAME_ = $^VARNAME
.ft P
.fi

In general, names that end with an underscore ``_'' will contain
\fIderived\fP values, i.e. values that are strictly related
to the original ones, apart from some special processing.

While names used in the CSA rc(1) context abide by the outlined rules,
variable and function names in the CSA AWK libraries follow a different
(slightly more C-like) convention. This is mainly because everything
that is created inside an rc(1) program script ends up in the program
environment, as already pointed-out, which calls for rather strict rules
not to cause unwanted interferences between programs. By contrast, with
AWK nothing is put in the program environment, end everything remains
strictly confined inside the AWK process. By cnvention, CSA special AWK
variables are assigned all upper-case names (i.e.: STDIN, STDOUT, etc.),
while CSA AWK library functions have names that are all lower-case.
A safe bet for the application program is therefore to use lower and
mixed-case names for its own AWK variables, and mixed-case names for its
own AWK functions.
.\" ---------------------------------------------------------------

.H 2 "Naming of data files and executable programs
Compound file and executable names will use hyphens (-) and/or underscores
(_) as name token separators, i.e. \f(CWmy-file\fP, or \f(CWmy_file\fP.
Using the dot (.) as a separator should be reserved to special cases, i.e.
to add file-type extensions
to files that need to be read by content-based systems; three-character
extensions (.txt, .jpg, ...), in particular, should be reserved for such
purpose.

.H 1 "Lock-files
The standard CSA library provides functions that are needed to
handle concurrent access to the data by multiple programs, and especially
to preserve file integrity during update operations. Concurrency is
handled through the use of \fIlock-files\fP, or \fIsemaphores\fP.
These can be created/destroyed with the relevant CSA library functions
\fIcsaLock()\fP and \fIcsaUnlock()\fP. Handling locks is a tricky subject,
due to the possibility of \fIrace-conditions\fP that may lead to
data corruption. These may occur whenever we have a test operation
followed by an action based on the result of the test. This test-action
sequence is \fInon-atomic\fP, hence the potential for races.
The low-level driver used by the above library functions to handle
locking is \fIlockfile(1)\fP, a utility especially conceived for
this purpose and that can safely be used also when the files to
be locked leave on NFS-mounted file-systems. Library functions
try also to cope gently with \fIstale-locks\fP, i.e. semaphores left
in place by processes that died prematurely, by calling
lockfile(1) with proper command-line options. Preventing \fIdead-locks\fP
is another issue that the library functions try to cope with, although
for this to be effective the application program must have been designed
sensibly in the first place.

Semaphores must be set whenever any of the following conditions are met:
.BL
.LI
A program needs to wite/delete data. If the operation is based on a
previous read operation, the lock must be set \fBbefore the read\fP
(reading+writing is non-atomic): this condition is called \fINon-Atomical
Write\fP (NAW).
.LI
A program needs to read data from multiple files, for instance as a
result of a \fIjoin\fP operation on CDS tables (i.e. a \fIview\fP).
If there is a chance that one or more of the involved files can be
modified while we are reading them, then all the files must be locked
before we start reading from any of them. This condition is called
\fINon-Atomical Read\fP (NAR). In the database terminology,
we need to make sure that nobody can break the \fIreferential integrity\fP
between the data that we are about to read from multiple,
phisically-indipendent but logically-dependent sources.
.LE

For instance, a CNS-layer hypotetical \fIauthCheck()\fP function will
write each request (or part of it) to a User Session File (USF), with
the two-fold purpose of logging the operation and keeping the session
alive by changing the file \fImtime\fP value. Although it is the USF
that is being modified, and not the user table, the two are logically
related; it may happen that while the USF is being changed, someone else
remove the relevant account from the application user database, thus causing
the USF to become orphaned. To preserve referential integrity
between the two entities we must then make sure that the procedure that
is used to remove the user record from the database will also remove the
associated USF. In many modern Database Management Systems (DBMS) this
is usually accomplished by means of so-called \fItriggers\fP.

Explicitly releasing lock-files is normally not necessary, as they
are removed automatically when a program calls \fIcsaExit()\fP or
one of its variations (\fIcsaExit.ok()\fP, \fIcsaExit.fault()\fP,
etc.). Removing locks with an explicit call to \fIcsaUnlock()\fP may be
necessary only if a program needs to iterate on multiple files before
exiting, and in general when it is expected to go on for a while before
calling \fIcsaExit()\fP. In such cases we should release the locks when
we no longer need them, or others may time-out while waiting to lock the
same resources.

Preserving referential-integrity contrains is another
application-specific issue. Consistency between primary keys (PK)
and foreign keys (FK), if necessary, will have to be ensured by
application-level functions, which must be designed together with the
database entities and their relations.

For example, as part of our database design we could write a hypotetical
\fIdeleteEmployee()\fP that removes
a specified entry from the \f(CWemployee\fP
table, \fBand\fP from the \f(CWemployee-deparment\fP relation table.

.H 1 "CDS-layer tables
The ``database system'' used by CSA to store local work data are simple
text files, as described by the book ``\fIUNIX Shell Programming\fP'',
listed in the bibliography. Although very primitive, this approach
can be quite appropriate and functional.

A number of filename \fIextensions\fP are tipically used to identify
data files in the CDS layer:

.BVL .2i
.LI \fIfile.data\fP
The actual data file
.LI \fIfile.data\fP,v
RCS \fIRepository\fP of \fIfile.data\fP
.LI \fIfile\fP.xref
Table cross-reference, or table \fIdictionary\fP. This is the mapping
between column names and their physical column number, plus optional
free-form comments.
.LI \fIfile.d\fP
Clustered table directory.
.LI \fIfile.data\fP.lock
Advisory lock on \fIfile.data\fP
.LE

Complicated, non-sequential data access structures, such as index files,
should be avoided if possible. To ensure good R/W performance, a potentially
large table should be made more manageable by distributing the PK space
into files, or \fIKey-Clusers\fP. The path to the cluster containing
a given key will then be
a \fIhash\fP function of the relevant key value. For instance, in a two-level
clustering the relative
path to the file cointaining the keys \fIgoofy\fP, \fIgoose\fP and
\fIgoblin\fP could be \f(CW./g/o.data\fP.

The main disadvantage of clustering is that casual queries, possibly on
the whole table, may require scanning the full set of clusters, with an
overhead that may become unacceptable under some circumstances.

A record primary key should never be reused for another record, even
when the original one is permanently deleted from the database. A record
key should represent a so-called GUID (Globally Unique ID), or even a
URN (Uniform Resource Name) identifier. Using a unique, non repeatable
identifier presents many advantages, and allows for unambiguous tracking
and auditing of a record history. For practical purposes, setting a key
value that is unique only within a specific database may usually suffice.

Apart from the record primary key, that should abide by the above
criteria, all other entity attributes (record fields) should contain
actual, human-readable information with a real meaning. That is,
whenever possible, information should be self-explanatory, although that
may require a bit more processing on the part of the machine to handle
it. More generally, human-readable textual data formats should always be
preferred over obscure binary ones, even at the price of reduced processing
speed. For the very same reason, in an ideal world all programs should
be fed into a computer directly in their source-code form; the fact that
as of today this is not always practical does not mean that it should
not be done at all, or that it will not be done in a future, when the
speed of computers won't be an issue any more.

The mapping of a record key to a file-system hierarchy is called
\fIPath-Based Clustering - PBC\fP in the context of this document. With
this technique, every directory and file-name along the path to the file
containing a given data record should reflect an actual record attribute
value. In order to attain a uniform clustering some experimentation
may be necessary. For instance, the grouping of keys may be based on
the first and second characters of their values, or on the first and
third, until an optimal clustering is attained. For instance, if keys
are english family names, grouping on the first and third characters can
produce better clustering.
.\" ---------------------------------------------------------------

.H 1 "Message tables
Program messages should never be hard-coded into the program code.
In CSA they are stored in external files containing
the relation msg_id/msg_text. The message text may contain substitution
tokens in the form of \fIprintf(1)\fP escape codes. Messages
are handled by the \fIcsaPrintMsg()\fP library function, that fetches
the specified message from the relevant table and operates the
necessary substitutions, based on parameters passed by the caller.

A message is composed by a key (message number) and a text.
Each program developer is assigned one or
more message pools that she can use, such as 1xxx, 2xxx, and so on,
so that programmers will not interfere with each other by reusing
message codes that have already been used by someone else.

The whole message table is split into PBC clusters, one per message
pool, i.e. per programmer or strictly related pool of programmers.
In this way, programmers can resolve message allocation conflicts
within a small group, without affecting the rest of the team.
Message codes are therefore assigned on a per-programmer rather
than on a per-program base, to allow one programmer to share the
same message texts between multiple programs of hers if desired.

Mesage pool 0xxx is reserved for CSA library messages, like 'file %s not
found', and other basic messages like that.

Given the same message code, when the message is printed
it must be assigned a \fIseverity code\fP, which may be different
between different programs or even between different invocations
of the same message by different parts of the same program. Such
severity code is an upper-case letter, that the calling program
must pass to \fIcsaPrintMsg()\fP according to the following table: 
.BVL .3i
.LI I
Informational
.LI W
Warning
.LI E
Error
.LE

Once a message has been issued it is up to the caller to decide
what to do next, like stopping execution or continuing with other
operations. Instead, it is up to \fIcsaPrintMsg()\fP to know how to get
the requested message, whether messages are organized into clusters,
performing localization (national language support) and logging the
message if appropriate.

Multi-lingual messages are supported through the CSA_LANG environment
variable, which must contain the language code to be used, like
\f(CWit\fP, \f(CWen_US\fP, and so on. The same variable is used
internally by CSA library routines that perform date conversion
and representation, which must abide by the local date conventions
(DD/MM/YYYY, MM/DD/YYYY, and so on).

.H 1 "List of global CSA variables
Each variable is tagged with a \fIScope\fP attribute that defines
whether it can be set/unset by the application
program or it is reserved for CSA internal use. A \fI``reserved''\fP
scope means that the variable can still be tested and used also by an
application program, but it must be considered read-only. If the scope
is \fI``profile''\fP, then the value can be set by an application
program, but its most proper setting place is the application profile.

.BVL .2i
.LI quote
The single-quote character.
.br
Default: octal \f(CW\e047\fP
.br
Scope: \fIall\fP

.LI tab
The horizontal-tab character.
.br
Default: octal \f(CW\e009\fP
.br
Scope: \fIall\fP

.LI nil
The empty \fIrc(1)\fP value.
.br
Default: \f(CW''\fP
.br
Scope: \fIall\fP

.LI nl
The newline character.
.br
Default: octal \f(CW\e010\fP
.br
Scope: \fIall\fP

.LI cr
The carriage-return character.
.br
Default: octal \f(CW\e013\fP
.br
Scope: \fIall\fP

.LI CSA_ACCOUNT
Current CSA UNIX user name. Better not to override it.
.br
Default: \f(CW`whoami\fP
.br
Scope: \fIprofile\fP

.LI CSA_AUDIT
If set to ``\fB1\fP'', then any changes to files done
through csaCommit() will be subject to rcs(1) versioning.
.br
Default: \fIunset\fP
.br
Scope: \fIprofile\fP

.LI CSA_AUTH_DOM
``\fBdomain\fP'' attribute of the User Session token\*F.
.br
Default: \fIunset\fP
.br
Scope: \fIprofile\fP
.FS
See \fIhttp://home.netscape.com/newsref/std/cookie_spec.html\fP for
more info on using client-state HTTP cookies to maintain sessions.
.FE

.LI CSA_AUTH_PATH
``\fBpath\fP'' attribute of the User Session token.
.br
Default: \fIunset\fP
.br
Scope: \fIprofile\fP

.LI CSA_AUTH_SSL
``\fBsecure\fP'' attribute of the User Session token.
.br
Default: \fIunset\fP
.br
Scope: \fIprofile\fP

.LI CSA_AUTH_USER
UNIX account that the current CSA application must run as.
If the application finds itself to be running under a different
account then it must "commit suicide", i.e. stop immediately with
an error message. CGI programs are often executed by setuid wrappers
and this security measure is meant to avod that, if the wrapper crashes,
the application program runs as root, with unpredictable and usually
dangerous effects on the integrity and security of the system.
.br
Default: \f(CWnobody\fP
.br
Scope: \fIprofile\fP

.LI CSA_CGIBIN
URL, either relative or absolute, of the CGI program directory on the
Web server.
.br
Default: \f(CW/cgi-bin\fP
.br
Scope: \fIprofile\fP

.LI CSA_CGIBIN2
Same as CSA_CGIBIN, but for SSL Web connections.
.br
Default: \f(CW$CSA_CGIBIN\fP
.br
Scope: \fIprofile\fP

.LI CSA_CMD_MD5
Name and arguments of the local md5sum(1) command, which is
run through a library function, as its output format varies
between different versions of UNIX/Linux.
.br
Default: \f(CWmd5sum\fP
.br
Scope: \fIprofile\fP

.LI CSA_CMD_PS
Name and arguments of the local ps(1) command, which syntax can
vary between different versions of UNIX/Linux.
.br
Default: \f(CWps h -u $CSA_AUTH_USER\fP
.br
Scope: \fIprofile\fP

.LI CSA_COMMIT
Reserved for CSA internal use. See mainlib.rc.
.br
Default: \fIunset\fP
.br
Scope: \fIreserved\fP

.\" .LI CSA_CONTEXT
.\" CSA execution context. Valid values can be either \f(CWCSA\fP or
.\" \f(CWCGI\fP.
.\" .br
.\" Default: \fICSA\fP
.\" .br
.\" Scope: \fIreserved\fP
.\" 
.LI CSA_COOKIE_
In authenticated Web sessions, whenever the server program sets a
client-side HTTP cookie through csaSetCookie(), like "foo=bar",
the cookie itself is also registered in the Client Session File as
"CSA_COOKIE_foo=bar". In this way the cookie remains in the availability
of the server program for verification purposes. A typical usage of this
feature is when a client operates a two-steps editing session on a file.
It must be possible for the server program to check whether the file was
modified by someone else while the first user was entering the edits
into her Web form. This can be accomplished by sending a file-content
checksum value to the client with a session or a cookie variable, along
with the data that is being edited. When the user submits her edits
the server program will then be able to check whether the two checksum
values still match, and behave accordingly.
.br
Default: \fIunset\fP
.br
Scope: \fIreserved\fP

.LI CSA_DEBUG
If set to "1", then the $CSA_ROOT/var/log/debug.log file will be
created, containing the CSA function-call trace and a lot of other
useful debugging information. Writing such file is quite expensive
in terms of extra system resources, so it should be avoided when not
necessary by setting CSA_DEBUG=0.
.br
Default: \f(CW0\fP
.br
Scope: \fIprofile\fP

.LI CSA_DOCROOT
Document-root directory of either the Web Server or the Virtual Host.
.br
Default: \f(CW$DOCUMENT_ROOT\fP
.br
Scope: \fIprofile\fP

.LI CSA_DOCROOT2
Same as CSA_DOCROOT, but for SSL Web connections.
.br
Default: \f(CW$CSA_DOCROOT\fP
.br
Scope: \fIprofile\fP

.LI CSA_GUIDLIST
List of Globally Unique IDs generated during the current run.
.br
Default: \f(CWunset\fP
.br
Scope: \fIreserved\fP

.LI CSA_HOST
Host-name of the Web Server running the current CSA application instance.
.br
Default: `\f(CW{hostname -s}\fP
.br
Scope: \fIreserved\fP

.LI CSA_HTMLEXT
File-name extension of HTML template files.
.br
Default: \f(CWhtml\fP
.br
Scope: \fIprofile\fP

.LI CSA_ID
CSA application name. It must comprise only chgaracters in
the set \f(CW[A-Za-z0-9_-]\fP, such as "foo", "test", "sample", etc.
.br
Default: \fIunset\fP
.br
Scope: \fIprofile\fP

.\" .LI CSA_IDXPP
.\" Index Post-Processor. If not-null, it must point to
.\" a user-supplied rc(1) script that can be
.\" sourced with ``.'' to re-index statically indexed NoSQL tables.
.\" The script can be built at run-time by an aplication program before
.\" calling nosqllib.rc:csaNosqlMerge().
.\" .br
.\" Default: \f(CW/dev/null\fP
.\" .br
.\" Scope: \fIall\fP
.\" ---------------------------------------------------------------------
.LI CSA_INSTALL
CSA installation directory.
.br
Default: \f(CW/usr/local/csa\fP
.br
Scope: \fIprofile\fP

.LI CSA_ISINDEX
Contents of the QUERY_STRING variable of an ISINDEX CGI request.
.br
Default: \fIunset\fP
.br
Scope: \fIreserved\fP

.LI CSA_LANG
Local language code for messages and Web pages, according to the usual
classification (en, en_US, it, en_UK, es, etc.). The selected language
must correspond to message and template directories that actually exist
on the server. Currently, CSA provides messages only in the "it" and
"en_US" versions.
.br
Default: \f(CWen_US\fP
.br
Scope: \fIprofile\fP

.LI CSA_LOCKS
Variable containing the list of the lock-files (semaphores) created
so far by the application through csaLock().
.br
Default: \fIunset\fP
.br
Scope: \fIreserved\fP

.LI CSA_MAXIDLE
User Session time-out interval, in minutes.
.br
Default: \f(CW30\fP
.br
Scope: \fIprofile\fP

.LI CSA_MAXPROC
Max. no. of active processes allowed on the system. If this limit is
exceeded then no new requests will be denied with an error message.
.br
Default: \fIunlimited\fP
.br
Scope: \fIprofile\fP

.LI CSA_MSG_NUM
Current message number.
.br
Default: \f(CW0000\fP
.br
Scope: \fIall\fP

.LI CSA_MSG_SEV
Current message severity.
.br
Default: \f(CW0000\fP
.br
Scope: \fIall\fP

.LI CSA_MSG_TEXT
Default message text.
.br
Default: \fIunset\fP
.br
Scope: \fIall\fP

.LI CSA_ONCOMMIT
Extra actions to be performed by csaCommit(). It must be a valid rc(1)
program fragment, properly escaped to make it eval-safe. It is up to the
application program to make sure that special rc(1) characters have been
properly escaped in the fragment.
.br
Default: \fIunset\fP
.br
Scope: \fIall\fP

.LI CSA_PGM
Name of the current CSA program, to be used in messages printed by
csaPrintMsg(). It is up to the application program to set this value
correctly.
.br
Default: \f(CWCSA\fP
.br
Scope: \fIall\fP

.LI CSA_PID
NFS-safe unique identificator of the current CSA program.
.br
Default: \f(CW$CSA_HOST.$pid\fP
.br
Scope: \fIreserved\fP

.LI CSA_PRID
Parent request-ID. It is usually set to the value of $CSA_RID by the Web
client program, to keep track of related request-response chains.
.br
Default: \fIunset\fP
.br
Scope: \fIall\fP

.LI CSA_REQUEST
Current client request URL.
.br
Default: \f(CW$REQUEST_URI\fP
.br
Scope: \fIreserved\fP

.LI CSA_RESULT
Used by many CSA library functions to return the function result to the
caller, thus saving a `{} subprocess.
.br
Default: \fIunset\fP
.br
Scope: \fIall\fP

.LI CSA_RID
Current request-ID.
.br
Default: \f(CW$CSA_HOST^_$pid\fP
.br
Scope: \fIreserved\fP

.LI CSA_ROOT
Current CSA application root directory.
.br
Default: \f(CW/\fP
.br
Scope: \fIprofile\fP

.LI CSA_RPC_CMD
Path to a temporary file containing the RPC executable request.
.br
Default: \f(CW$TMPDIR/rpc$pid.tmp\fP
.br
Scope: \fIreserved\fP

.LI CSA_RPC_FMT
Tells CSA that XML-RPC output formatting is required.
.br
Default: \fIunset\fP
.br
Scope: \fIreserved\fP

.LI CSA_RPC_MULTI
Tells CSA programs that the current request is a \fIsystem.multicall\fP.
See http://www.xmlrpc.com/discuss/msgReader$1208 for more on this.
.br
Default: \fIunset\fP
.br
Scope: \fIreserved\fP

.LI CSA_RPC_XML
Path to a temporary file containing the XML request source, if any.
.br
Default: \f(CW$TMPDIR/xml$pid.tmp\fP
.br
Scope: \fIany\fP

.LI CSA_RPC_PYE
Path to a temporary file containing the STDERR output from
the PYX translation of the input XML request.
.br
Default: \fIdinamically set\fP
.br
Scope: \fIreserved\fP

.LI CSA_RPC_PYX
Path to a temporary file containing the PYX translation of
the input XML request, if any.
.br
Default: \fIdinamically set\fP
.br
Scope: \fIany\fP

.LI CSA_RPC_MAXSIZE
Max. size in bytes of input data supplied to RPC calls over the Web
(either as GET or POST requests, or both).
.br
Default: \f(CW10000\fP
.br
Scope: \fIprofile\fP

.LI CSA_RPC_WWW
Path to a temporary file containing the XML-RPC method call
variables, in \fIrc(1)\fP syntax. See doc/pyx2csa.txt for
more explanations.
.br
Default: \fIdinamically set\fP
.br
Scope: \fIany\fP

.LI CSA_STATUS
Generic CSA error flag, used by some of the library functions.
.br
Default: \f(CW0\fP
.br
Scope: \fIall\fP

.LI CSA_TEST_MODE
Generic flag to tell programs that we are running in test mode. Whether
to test this flag is up to the application programs. One possible use
would be for an application component that sends e-mail messages: if
this flag is set then the program could perform a "dry" run, refraining
from actually sending annoying test messages to users.
.br
Default: \f(CW0\fP
.br
Scope: \fIprofile\fP

Date and time values. The values account DST if any. Variable names are
assigned as follows, from the output of the following command:
.sp
\f(CW* =\fP `\f(CW{date -d now '+%Y %m %d %H %M %S %Z %a %b %s %z'}\fP

The ``\f(CWnow\fP argument of date(1) can be overridden by an explicit
call to csaSetTime(). See mainlib.rc for more info.
.sp
.nf
.ft CW
CSA_TIME_YEAR = $1
CSA_TIME_MONTH = $2
CSA_TIME_DAY = $3
CSA_TIME_HOUR = $4
CSA_TIME_MIN = $5
CSA_TIME_SEC = $6
CSA_TIME_TZ = $7
CSA_TIME_STAMP = $1$2$3$4$5$6
CSA_TIME_ISO = $1$2$3^T$4:$5:$6
CSA_TIME_ISO2 = $1-$2-$3' '$4:$5:$6
CSA_TIME_ISO3 = $1-$2-$3^T$4:$5:$6$11
CSA_TIME_ISO4 = $1-$2-$3^T$4:$5:$6
CSA_TIME_DNAME = $8
CSA_TIME_MNAME = $9
CSA_TIME_UNIX = $10
CSA_TIME_LOG = $CSA_TIME_ISO2.$CSA_TIME_TZ
.fi
.ft P

.LI CSA_TXTEXT
File-name extension of text template files.
.br
Default: \f(CWtext\fP
.br
Scope: \fIprofile\fP

.LI CSA_URL
.br
Base URL of the current CSA server application.
.br
Default: \f(CWhttp://localhost\fP
.br
Scope: \fIprofile\fP

.LI CSA_URL2
Same as CSA_URL, but for SSL Web connections.
.br
Default: \f(CW$CSA_URL\fP
.br
Scope: \fIprofile\fP

.LI CSA_USER_ID
.br
Remote User ID. Usually required by the application-level login
procedure to begin an authenticated user session.
.br
Default: \fIunset\fP
.br
Scope: \fIall\fP

.LI CSA_USER_PBC
.br
User Path-Based Clustering index. This is the relative directory
tree under which pieces of data belonging to the current Web user
can be found in PBC structures. For instance, if the current user-ID
is \f(CWgoofy\fP then the associated CSA_USER_PBC value
will be \f(CWg/o\fP, that is the first two charecters of the user-ID,
separated by a slash ``/''.
.br
Default: \fIunset\fP
.br
Scope: \fIall\fP

.LI CSA_USF_CACHE
.br
Default pattern that environment variables must match to be saved in
the current User Session File (USF).
.br
Default: \f(CW^(CSA_USER_ID$|CSA_USF_TIME$|CSA_COOKIE_)\fP
.br
Scope: \fIreserved\fP

.LI CSA_USF_TIME
.br
User Session File (USF) last-modified timestamp.
.br
Default: \f(CW$CSA_TIME_ISO\fP
.br
Scope: \fIreserved\fP

.LI CSA_VERSION
.br
Current CSA version
.br
Default: \fIfixed\fP
.br
Scope: \fIreserved\fP

.LI CSA_WBMSG
Write-back message. This is a variable through which a sub-program,
i.e. a called process, can request the parent rc(1) program to print
a CSA message through csaPrintMsg(). This capability requires that
the caller capture the called program output into a temporary file,
which is then sourced with the ``.'' shell operator. After sourcing the
generated script file, the caller must then test the content of said
variable and take the proper actions. Building a source-safe script is
the responsibility of the called program.
.br
Default: \fIunset\fP
.br
Scope: \fIreserved\fP

.LI CSA_WORKFILES
.br
List of the work-files created by the CSA application up to that point.
Such files will be removed on exit by csaExit().
.br
Default: \fIunset\fP
.br
Scope: \fIreserved\fP

.LI CSA_XMLCALL
.br
Default: \fIunset\fP
.br
Scope: \fIreserved\fP
.br
Web GET/POST variable, containing an RPC request XML message. The CSA
CGI library currently supports two forms of XML-encoded RPC request,
in the following order:
.br
.BVL .2i
.LI xmlrpc-raw-post
The plain XML data is contained in the POST body, unencoded. This is,
for example, the way current XML-RPC implementations work.
.LI xmlrpc-form-urlencoded
The encoded XML request is passed via the CSA_XMLCALL variable, either
in a POST message body or in the URL string (QUERY_STRING).
.LE

Notes:
.BL
.LI
The only XML payload type currently understood is XML-RPC.
.LI
CSA uses a MIME-RPC style remote method call syntax. This means
that the actual remote method name is taken from the URL, \fInot\fP
from the \f(CW<methodName>\fP XML-RPC element. The content of the latter,
whatever it be, is disregarded. It is therefore suggested that it
is always set equal to \f(CW<methodName>EXTERNAL</methodName>\fP.
This is to mean that the method specification relies on the
marshalling facility that is used to deliver the message, HTTP in this case.
.LE

.LI REMOTE_USER
.br
Name of the file containing the Web client session data. It can either
be the value passed to the CGI interface by server-based authentication
or, if cookie-based authentication is in use, it is a user table primary
key followed by a hyphen ``-'' and then followed by an MD5-encrypted
session token. For instance: \f(CWgoofy-401b30e3b8b5d629635a5c613cdb7919\fP.
.br
Default: \fIunset\fP
.br
Scope: \fIreserved\fP
.LE

.H 1 "Glossary
.BVL .2i
.LI CGI
Common Gateway Interface
.LI CDS
CSA Data Storage
.LI CSA
Command Scripting Architecture
.LI CNS
Custom Name Space
.LI USF
User Session File
.LI ERD
Entity-Relationship Diagram
.LI FK
Foreign Key
.LI LF
Lock File
.LI NAR
Non-Atomical Read
.LI NAW
Non-Atomical Write
.LI PBC
Path-Based Clustering
.LI PK
Primary Key
.LI SOAP
Simple Object Access Protocol
.LI XML
eXtensible Markup Language
.LE
.\" ---------------------------------------------------------------

.H 1 Bibliography
.AL
.LI
B. Kernighan and R. Pike, \fIThe UNIX Programming Environment\fP,
Prentice Hall, Englewood Cliffs, NJ, 1985.
.LI
Mike Gancarz, \fIThe UNIX Philosphy\fP, Digital Press, 1995.
.LI
R. Manis, E. Schaffer and R. Jorgensen, \fIUNIX Relational Database
Management\fP, Prentice Hall, Englewood Cliffs, NJ, 1988.
.LI
Alfred V. Aho, Brian W. Kernighan and Peter J. Weinberger,
\fIThe AWK Programming Language\fP, Addison-Wesley, 1988.
.LI
L.J. Arthur and T. Burns, \fIUNIX Shell Programming\fP,
John Wiley & Sons, 1997. 
.LI
Dale Dougherty, \fIsed & awk,\fP, O'Reilly, 1992.
.LI
John Roll, \fIstarbase - an ASCII relational database for UNIX.\fP,
.br
http://cfa-www.harvard.edu/~john/starbase/starbase.1.html
.LI
Carlo Strozzi, \fINoSQL - A Relational Database Management System\fP,
.br
http://www.linux.it/~carlos/nosql/
.LE

\fBNote:\fP all brand names, product names, or trademarks mentioned
in this publication belong to their respective holders.
.\" ---------------------------------------------------------------

.\" Appendix.
.\" .nr Aph 0	.\" Override APP default setting, see groff_mm(7).
.\" .APP "" "GNU Free Documentation License
.\" One-column mode.  
.\" .1C
.\" .ce 2
.\"		GNU Free Documentation License
.\"
.\"		   Version 1.1, March 2000
.\"
.\" .... etc ... (FDL text separated from this document).
.\"
.\" Table Of Contents
.TC
.\" End of document.
