# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2001,2002,2003 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: _adddays.awk,v 1.1 2004/08/08 21:15:38 carlo Exp $
# =====================================================================
# string _adddays(string date, int days)
#
# Takes two numeric arguments in the for of 'YYYYmmdd,days', adds 'days'
# to 'yyyymmdd' and returns the result in the form of 'yyyymmdd'. If
# 'days' is a negative number then it is subtracted from 'yyyymmdd'.
# Note: this function requires the GNU version of date(1).
# =====================================================================

function _adddays(date, days) {

  # Do not waste time if there is nothing to do.
  if (days == _NULL) return date

  if (days > 0) {
     _CMD = "exec date --date '" date " " days " day' +%Y%m%d"
  }  else {
     # Make it a positive number.
     days = days + -2 * days
     _CMD = "exec date --date='" date " " days " day ago' +%Y%m%d"
  }

  _CMD | getline date
  close(_CMD)
  return date
}

